#ifndef CONSTANTS_H
#define CONSTANTS_H
// Copyright (c) 2005 David Drysdale.  See license.txt for license info

#include "resourcedefines.h"

#ifdef DEBUG_BUILD
#define assert(X) {if (!(X)) ErrFatalDisplay(#X);}
#define DEBUG(F)\
{\
  Char T[128];\
  StrPrintF F;\
  if (FrmCustomAlert(DebugAlert, T, NULL, NULL) != 0) {\
    ErrFatalDisplay(T);\
  }\
}
#else
#define assert(X)
#define DEBUG(F)
#endif

// The minimum OS version we support
#define kOurMinVersion	sysMakeROMVersion(3,0,0,sysROMStageRelease,0)

// Graphics Constants

// Cell size in pels
#define kCellSize    14
// Number of cells visible on screen
#define kHorizCells  10
#define kVertCells    9

// Delay waiting for input
#define kBlockTicks  35

// Number of seconds penalty for defusing
#define kDefuseTime   8

// Number of ticks to wait to make the incrementing counter visible
#define kNumberShowDelay 10

// Sizes of predefined boards
#define kSmallWidth             9
#define kSmallHeight            9
#define kMediumWidth           16
#define kMediumHeight          16
#define kLargeWidth            30
#define kLargeHeight           16
#define kMinWidth               3 
#define kMinHeight              3
#define kMaxWidth              50
#define kMaxHeight             50

// Difficulties on predefined boards
#define kSmallEasy             10
#define kSmallMedium           13
#define kSmallHard             17
#define kMediumEasy            30
#define kMediumMedium          40
#define kMediumHard            55
#define kLargeEasy             60
#define kLargeMedium           75
#define kLargeHard             99
#define kMinMines               2
#define kMaxMines             150

// Mine densities for custom size boards
#define kScalingFactor   100
#define kEasyRatio       (kScalingFactor*kSmallEasy/(kSmallWidth*kSmallHeight))
#define kMediumRatio     (kScalingFactor*kMediumMedium/(kMediumWidth*kMediumHeight))
#define kHardRatio       (kScalingFactor*kLargeHard/(kLargeWidth*kLargeHeight))

// Worst best time
#define kTimeLimit            999

#endif
